#!/usr/bin/python

import os
import os.path
from optparse import OptionParser
from sets import Set

import tptp
import selection

opt_parser=OptionParser()
opt_parser.add_option('-t', '--tptp_dir', type='string', default='')
opt_parser.add_option('-b', '--benevolence', type='float', default=1.0)

opts, args=opt_parser.parse_args()

tptp_dir=opts.tptp_dir
if not tptp_dir:
	if 'TPTP' in os.environ:
		tptp_dir=os.environ['TPTP']
if tptp_dir:
	tptp.AxiomSet.file_prefix=tptp_dir

problem_fname=args[0]

problem=tptp.Problem(problem_fname)
problem.active=True

if problem.axiom_sets:
	selector=selection.Selector(axiom_set_set=problem.axiom_sets, params=selection.SelectionParams(benevolence=opts.benevolence))
	forms=selector.select_for_problem(problem)
else:
	forms=Set()
forms.update(problem.own_formulas.itervalues())

for form in forms:
	print form

