from sets import Set

class ArgumentError(Exception):
	pass

def invert_list(lst):
	res={}
	for i in range(0,len(lst)):
		res[lst[i]]=i
	return res

def all_pairs_dijkstra_path_length(G):
	import networkx as NX
	res={}
	for n in G.nodes_iter():
		res[n]=NX.single_source_dijkstra_path_length(G,n)
	return res


class HashableList(list):
    def __hash__(self):
	res=0
	for itm in self:
	    res^=hash(itm)
	return res

class HashableDict(dict):
    def __hash__(self):
	res=0
	for key,val in self.iteritems():
	    res^=hash(itm)^(hash(key)<<1)
	return res

props=HashableDict

def get_uodict_key(key):
	o1,o2=key
	if o1<o2:
		return (o2,o1)
	else:
		return key

class UnorderedPairDict(object):
	def __init__(self, generator=None):
		self.data={}
		self.generator=generator
		
	def __getitem__(self, key):
		if self.generator:
			return self.get_or_generate(key)
		else:
			return self.data[get_uodict_key(key)] 
	def __setitem__(self, key, value):
		self.data[get_uodict_key(key)]=value
	
	def iterkeys(self):
		return self.data.iterkeys()
	def get_or_generate(self, *args):
		if len(args)==1:
			inner_key=get_uodict_key(args[0])
		elif len(args)==2:
			inner_key=get_uodict_key((args[0],args[1]))
		else:
			raise ArgumentError
		res=self.data.get(inner_key, -1)
		if res==-1:
			res=self.generator(inner_key)
			self.data[inner_key]=res
		return res
		